package VistaControlador;

import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.time.LocalDate;
import java.time.Month;
import java.util.ArrayList;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;
import javax.swing.JTextArea;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import Logica.Gestion;
import Logica.Meses;

public class Menu extends JFrame{
	protected JPanel panelCentral;
	protected JTabbedPane pestania;
	protected VistaAniadirVisualizar ingresos;
	protected VistaAniadirVisualizar gastos;
	protected VistaPanelLateral panel;
	Meses meses;
	ArrayList<VistaAniadirVisualizar> pestanias;
	protected Gestion datosGastos;
	protected Gestion datosIngresos;
	public Menu() {
		this.meses=new Meses();
		meses.aniadirGestion("Ingresos", LocalDate.now().getYear(), LocalDate.now().getMonth());
		meses.aniadirGestion("Gastos", LocalDate.now().getYear(), LocalDate.now().getMonth());
		VistaAniadirVisualizar.setPanelLateral(panel);
		//this.datosGastos = new Gestion();
		//this.datosIngresos = new Gestion();
		this.setLayout(new GridBagLayout());
		GridBagConstraints constrain = new GridBagConstraints();
		this.panel = new VistaPanelLateral(constrain);
		this.ingresos = new VistaAniadirVisualizar(this,meses.getGestionesActuales().get(0),true);
		this.gastos = new VistaAniadirVisualizar(this,meses.getGestionesActuales().get(1),false);
		this.panelCentral = new JPanel();
		this.pestania = new JTabbedPane();
		constrain.fill = GridBagConstraints.VERTICAL;
		constrain.gridx = 0;
		constrain.gridy = 0;
		constrain.weightx = 2;
		this.panelCentral.add(pestania,constrain);
		this.pestania.addTab("Ingresos", ingresos);
		this.pestania.addTab("Gastos", gastos);
		getContentPane().add(pestania);
		setTitle("Titulo");
		setSize(new Dimension(420,320));
		setDefaultCloseOperation(3);
		setLocationRelativeTo(null);
		ControladorAniadirVisualizar controlador = new ControladorAniadirVisualizar(this.ingresos);
		ControladorAniadirVisualizar controlador2 = new ControladorAniadirVisualizar(this.gastos);
		ControladorPanelLateral controlador3 = new ControladorPanelLateral(this.panel);
		//this.panel.actualizarDatos(datosIngresos);
		this.pestania.addChangeListener((ChangeListener)->{
			if(this.pestania.getSelectedIndex() == 0) {
				this.panel.actualizarDatos(meses.getGestionesActuales().get(0));
			}else {
				this.panel.actualizarDatos(meses.getGestionesActuales().get(1));
			}
		});
		this.add(this.panel);
	}
	
	
	
	private void iniciarMes(int anio, Month mes) {
		this.meses=new Meses();
		meses.aniadirGestion("Ingresos", anio, mes);
		meses.aniadirGestion("Gastos", anio, mes);
		this.pestanias.add(new VistaAniadirVisualizar(this,meses.getGestionesActuales().get(0),true));
		this.pestanias.add(new VistaAniadirVisualizar(this,meses.getGestionesActuales().get(1),false));
	}
	
	private void cargarGestiones(int anio, Month mes) {
		this.meses.elegirMes(anio, mes);
		if(this.meses.getGestionesActuales().size() == 0) {
			this.iniciarMes(anio, mes);
		}
	}
	
	private void cargarPestanias() {
		this.pestania.removeAll();
		for(VistaAniadirVisualizar vista:this.pestanias) {
			this.pestania.add(vista);
		}
	}
	
}
